from __future__ import annotations

from typing import TYPE_CHECKING, Protocol

if TYPE_CHECKING:
    from datetime import datetime


class ITask(Protocol):
    """Interface for heartbeat tasks."""

    def setup(self) -> None: ...
    def teardown(self) -> None: ...
    def run(self) -> None: ...
    @property
    def first_delay(self) -> float: ...
    @property
    def interval(self) -> float: ...
    @property
    def latest_run(self) -> datetime: ...
    @property
    def name(self) -> str: ...
